type: prog

titre: Produits récupérés

niveau: défi

objectif: Manipuler un fichier binaire contenant les informations des produits

énoncé: |
  On souhaite enregistrer dans un **fichier binaire** `produits.dat` les informations des **produits** commercialisés par une entreprise.

  Les  informations sont le `code` du produit, son `nom` et son `prix` unitaire.

  Ces informations sont reçues en entrée en boucle avec une `question` si `oui`ou `non` on désire continuer à entrer un produit.

  On souhaite ensuite lire le fichier `produits.dat` afin de récupérer les données binaires pour produire en sortie des statistiques dont le **prix moyen**, le **code** des produit les **plus chers** et le **code** des produits les **moins chers**.

  ### Entrées

  - **code** : identifiant le produit (chaine de caractères)
  - **nom** : décrivant le produit (chaine de caractères)
  - **prix** : unitaire à la vente du produit (nombre réel)
  - **question** : pour continuer l'entrée en boucle des informations d'un produit (chaine de caractères `oui` ou `non`)

  ### Sortie attendue

  La **moyennee** des prix (nombres réel), les **codes** des produits les **plus chers** et les **codes** des produits les **moins chers** (chaines de caractères)

  ### À faire

  Compléter le code afin d'écrire dans le fichier `produits.dat` les informations des **produits**, pour en produire en sortie la **moyenne** des prix des produits suivie des **codes** des produits les plus chers puis ceux des produits les moins chers en suivant le modèle des exemples ci-dessous

  ### Exemples

  1. Un seul produit

  - Entrées :
  ```
    A100
    Abri
    300
    non

  ```
  
  - Sortie attendue :
  ``` 
    La moyenne des prix est 300.0 $
    Le(s) code(s) du produit le plus cher : A100
    Le(s) code(s) du produit le moins cher : A100

  ```

  2. Plusieurs produits

  - Entrées :
  ```
    A100
    Abri
    300
    oui
    B20
    Barre
    400
    oui
    C12
    Clochette
    260
    oui
    P45
    Porte
    260
    non

  ```
  
  - Sortie attendue :
  ``` 
   La moyenne des prix est 305.0 $
   Le(s) code(s) du produit le plus cher : B20
   Le(s) code(s) du produit le moins cher : C12 , P45

  ```
ébauches:
  java: !include Produit.java


rétroactions:
  positive: Bravo !
  négative: Revoir la syntaxe d'écriture et lecture dans un fichier binaire

tests: !include tests.yml

auteur: Wafaa Niar Dinedane / Patrick Lafrance
licence: 2021 CC-BY-SA

